#include <avr/io.h>

#include "HAL.h"

#define PWM_MAXVALUE_15KHZ			492		/* 14.7456 MHz / 2 / 15kHz -> 491.52 */
#define PWM_MAXVALUE_20KHZ			369		/* 14.7456 MHz / 2 / 20kHz -> 368.64 */
#define PWM_MAXVALUE				PWM_MAXVALUE_15KHZ

uint16_t pwmGetMaxValue(void) {
	return PWM_MAXVALUE;
}

void pwmSetRawValue(uint16_t aValue) {
	OCR1A = aValue;
}

void pwmInit(void) {
	OCR1A = 0;
	ICR1 = PWM_MAXVALUE;			
//	ICR1 = 369;			
	/* WGM 8, COM 2 */
	TCCR1A = _BV(COM1A1);
	TCCR1B = _BV(WGM13) | _BV(CS10);
}
